﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EggSpawner : MonoBehaviour
{
    public GameObject prefab;
    public Transform spawnPoint;
    public float zShift = 0.5f;
    Plane plane;
    // Start is called before the first frame update
    void Start()
    {
        plane = new Plane(Vector3.forward, spawnPoint.position);
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetMouseButtonDown(0))
        {
            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
            float dist;

            if (plane.Raycast(ray, out dist))
            {
                Vector3 pos = ray.GetPoint(dist);
                pos.z += Random.Range(-zShift, zShift);
                Instantiate(prefab, pos, Quaternion.identity);
            }
        }
    }
}
