﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Eyeball : MonoBehaviour
{
    public static Transform globalTarget;

    public Transform brow;
    public Transform pupilOrigin;
    public Transform pupil;

    public Transform target;

    public float radius = 1f;

    public AnimationCurve angerCurve;

    [Range(-1, 1)]
    public float anger;

    private void Update()
    {
        if (target != null || globalTarget != null)
        {
            Vector3 delta = (globalTarget != null ? globalTarget.position : target.position) - pupilOrigin.position;

            delta.z = 0;

            if (delta.magnitude > radius)
            {
                delta.Normalize();
                delta *= radius;
            }
            delta.x *= -1 * Mathf.Sign(transform.localScale.x);
            pupil.localPosition = delta;
        }
        else
        {
            pupil.localPosition = Vector3.Lerp(pupil.localPosition, Vector3.zero, Time.deltaTime * 15);
        }

        brow.localRotation = Quaternion.Euler(0, 0, angerCurve.Evaluate(anger));
    }
}
